/**
 * Program: ForwardCommand.java
 * This simple command just forwards the browser to the next JSP page
 * specified in the constructor.
 */

package extensions.gem;
import javax.servlet.*;
import javax.servlet.http.*;

public class ForwardCommand implements Command {
    /**
     * Constructor: sets the next page to show.
     * @param String nextPage  the name of the JSP page to load.
     */ 
    String nextPage;
    public ForwardCommand(String nextPage) {
	this.nextPage=nextPage;
    }

    /**
     * Don't really need to do anything here, just return the name
     * of the next page to display.  However, we have the entire
     * request object, so other command classes may do all kinds of
     * things like call setPropBean and so on. 
     */
    public HttpServletResponse execute(HttpServletRequest req,
				       HttpServletResponse res) {
	return res;
    }

    public String getNextPage() { return nextPage; }
}
