/**
 * Program: ForwardCommand.java
 * This simple command just forwards the browser to the next JSP page
 * specified in the constructor.
 */

package extensions.csm;
import javax.servlet.*;
import javax.servlet.http.*;

public class ValidateCommand implements Command {
    /**
     * Constructor: sets the next page to show.
     * @param String nextPage  the name of the JSP page to load.
     */ 
    String nextPage,batchPath;
    AuthenticateBean auth;
    String objName;

    public ValidateCommand(String nextPage,String objName) {
	this.nextPage=nextPage;
	this.objName=objName;
    }

    /**
     * Don't really need to do anything here, just return the name
     * of the next page to display.  However, we have the entire
     * request object, so other command classes may do all kinds of
     * things like call setPropBean and so on. 
     */
    public HttpServletResponse execute(HttpServletRequest req,
				       HttpServletResponse res) {
	auth=(AuthenticateBean)req.getSession().getAttribute("auth");
	//	auth.test();
	res=auth.setUpLogin(req,res);
	return res;
    }

    public String getNextPage() { return nextPage; }
}
