package extensions.gem;

import com.ibm.xml.*;
import com.ibm.xml.parser.*;
//import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.w3c.dom.*;
//import com.ibm.xml.framework.*;

public class parseGOW {

    Vector keyVec = new Vector(); // keyVec is the key vector.
    Vector valueVec = new Vector(); // valueVec is the value vector.
    String value = null;
    Hashtable hash = new Hashtable();
    boolean initialized=false;

    Document doc;
    Element baseElem;
    Parser parser;

    public parseGOW() {
    }
    
    /**
     * Initialize the parser.  
     */    
    public void init(String xmlfilename) {
        if (xmlfilename == null) {
            System.err.println("Missing xmlfilename.");
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);
	    
            // Start parsing
            parser = new Parser(xmlfilename);
	    
            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.err.println("Errors > zero");
            }
	    
	    // Document is well-formed
            doc = parser.readStream(is);
            baseElem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(baseElem);
	    initialized=true;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    

    /**
     * An obsolete method.
     */
    public int doParse(String xmlfilename){
	String key = null, value = null;
	String tagID = null;
	int nApplications = 0;

	init(xmlfilename);
	
	Vector outerXSILTag = getAllTags(baseElem, "XSIL");
	nApplications = outerXSILTag.size();

	Node nextnode = baseElem.getFirstChild();
	Vector inXSILTags = getAllTags(nextnode, "XSIL");
	nApplications = inXSILTags.size();
	removeWhiteSpaceNodes((Element)nextnode);
	
	NodeList nodelist = baseElem.getChildNodes();
	buildNodes(nodelist, tagID);
	// Make the hash table from the name/value pairs.
	for(int i = 0; i < keyVec.size(); i++){
	    hash.put(keyVec.get(i), (valueVec.get(i) + "+"));
	}
	return nApplications;
    }


    /**
     * Uses the base BaseElement baseElem that we obtained in the init
     * method.
     */
    public boolean removeApplication(String xmlfilename, String applName) {
	String tagID = null;
	boolean status = false;

        try {
	    Node nextnode = baseElem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);

	    Vector inXSILTags = getAllTags(nextnode, "XSIL");
	    
	    int nAppl = inXSILTags.size();
	    for (int j = 0; j < nAppl; j++) {
		Node applNode = (Node)inXSILTags.elementAt(j);
		if(((Element)applNode).getAttribute("Name").equals(applName)){
		    nextnode.removeChild(applNode);
		    status = true;
		}
	    }
	} catch (Exception e) {
	    System.err.println(e+" while removing the application" );
	    status = false;
	}
	
  	// Save the XML document
  	try{
  	    PrintWriter xmlFileOut=
  		new PrintWriter(new FileWriter(xmlfilename, false));
  	    ((TXDocument)doc).printWithFormat(xmlFileOut);
  	} catch(IOException e){
  	    System.err.println("Error opening xmlFileOut.");
  	    System.exit(0);
  	}
  	return status;
    }
    
    
    /* 
       Hahtable (key/value)
       ===================
       key        |  value
       ===================
       applName   |
       -------------------
       paramInNum |
       -------------------
       infileNum  |
       -------------------
       paramOutNum |
       -------------------
       outfileNum |
       -------------------
       iostyle    |
       -------------------
       hostName   |
       -------------------
       queueType  |
       -------------------
       execPath   |
       -------------------
       workDir    |
       -------------------
       qsubPath   |
       ===================
    */
    
    public boolean addApplication(String xmlfilename, 
				  Hashtable applData,
				  Hashtable hostData) {
	boolean status = false;
	Element item, itemA=null, itemB=null,itemC=null;

	if(!initialized) init(xmlfilename);

	//Remove the application from the xml file.
	removeApplication(xmlfilename,(String)applData.get("applName"));

        try {
	    Node nextnode = baseElem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);
	    
	    //  Make an application element and add it
	    //  as a child of root
	    item = doc.createElement("XSIL");
	    item.setAttribute("Name",(String)applData.get("applName"));
	    item.setAttribute("Type","gem.parseXMLDesc");
	    
	    //Sweep through applData entries and add to the 
	    //list.
	    Enumeration en=applData.keys();
	    while(en.hasMoreElements()){
		String paramname=(String)en.nextElement();
		if(applData.get(paramname) instanceof String) {
		    if(!paramname.equals("applName")) {
			itemA=doc.createElement("Param");
			itemA.setAttribute("Name",paramname);
			itemA.appendChild(doc.createTextNode((String)applData.get(paramname)));
			item.appendChild(itemA);		    
		    }
		}
	    }
	    
	    //Now sweep though the host hashtable.  Note that I
	    //am assuming all entries in the hashtable hostData 
	    //are arrays of the same size.
	    Object[] objhosts=(Object[])applData.get("HostName");
	    for(int i=0;i<objhosts.length;i++) {
		itemB=doc.createElement("XSIL");
		itemB.setAttribute("Name",(String)objhosts[i]);
		itemB.setAttribute("Type","gem.parseXMLHost");
		Enumeration en2=hostData.keys();
		while(en2.hasMoreElements()) {
		    String paramname=(String)en2.nextElement();
		    itemC=doc.createElement("Param");
		    Object[] paramobj=(Object[])hostData.get(paramname);
		    itemC.setAttribute("Name",paramname);
		    itemC.appendChild(doc.createTextNode((String)paramobj[i]));
		    itemB.appendChild(itemC);
		}
		item.appendChild(itemB);
	    }
	    nextnode.insertBefore((Node)item,null);
	    status = true;
	} catch (Exception e) {
	    e.printStackTrace();
	    System.err.println(e+" while adding the application" );
	    status = false;
	}
	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			   new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }

    
    /**
     * Obsolete method.
     */
    public boolean modifyHostname(String xmlfilename, 
				  String applName, 
				  Hashtable tableData) {
	boolean status = false;

        try {

	    Node nextnode = baseElem.getFirstChild();  //XSIL application list
	    removeWhiteSpaceNodes((Element)nextnode);

	    //find "applicatin" node
	    Node applNode = null;
	    for(applNode = nextnode.getFirstChild(); applNode!=null;
	    applNode = applNode.getNextSibling()) {
	    if(applNode instanceof Element) {
		if(((Element)applNode).getAttribute("Name").equals(applName)) {
		    System.out.println("Node Name Tag: "+applNode.getNodeName());
		    System.out.println("Attribute: "+((Element)applNode).getAttribute("Name"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)applNode);

	    //find "Table" node
	    Node tableNode = null;
	    for(tableNode = applNode.getFirstChild(); tableNode!=null;
	    tableNode = tableNode.getNextSibling()) {
	    if(tableNode instanceof Element) {
		if(tableNode.getNodeName().equals("Table")) {
		    System.out.println("Node Name Tag: "+tableNode.getNodeName());
		    System.out.println("Attribute: "+((Element)tableNode).getAttribute("Name"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)tableNode);

	    //find "Stream" node
	    Node streamNode = null;
	    for(streamNode = tableNode.getFirstChild(); streamNode!=null;
	    streamNode = streamNode.getNextSibling()) {
	    if(streamNode instanceof Element) {
		if(streamNode.getNodeName().equals("Stream")) {
		    System.out.println("Node Name Tag: "+streamNode.getNodeName());
		    System.out.println("Attribute: "+((Element)streamNode).getAttribute("Delimiter"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)streamNode);

	    String hostName = (String)tableData.get("hostName");
	    String queueType = (String)tableData.get("queueType");
	    String execPath = (String)tableData.get("execPath");
	    String workDir = (String)tableData.get("workDir");
	    String qsubPath = (String)tableData.get("qsubPath");

	    StringTokenizer sthostname = new StringTokenizer(hostName,"+");
	    StringTokenizer stqueuetype = new StringTokenizer(queueType,"+");
	    StringTokenizer stexecpath = new StringTokenizer(execPath,"+");
	    StringTokenizer stworkdir = new StringTokenizer(workDir,"+");
	    StringTokenizer stqsubpath = new StringTokenizer(qsubPath,"+");

	    String streamData = "";
	    while(sthostname.hasMoreTokens()) {
		System.out.println("has more tokens");
		String hntoken = sthostname.nextToken();
		String qttoken = stqueuetype.nextToken();
		String eptoken = stexecpath.nextToken();
		String wdtoken = stworkdir.nextToken();
		String qptoken = stqsubpath.nextToken();

		streamData += hntoken+","+qttoken+","+eptoken+","+wdtoken+","+qptoken+"\n";
	    }

	    tableNode.removeChild(streamNode);
	    Element item = doc.createElement("Stream");
	    item.setAttribute("Delimiter",",");
	    item.appendChild(doc.createTextNode(streamData));

	    tableNode.insertBefore((Node)item, null);
	    status = true;

	} catch (Exception e) {
	    System.out.println(e+" while modifying the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }


    public void removeWhiteSpaceNodes(Element parent) {
	Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild(); nextNode != null;) {
	    child = nextNode;
	    nextNode = child.getNextSibling();
	    
            if (child instanceof TXText){
		if(((TXText)child).getIsIgnorableWhitespace()){
		    parent.removeChild(child);
		}
            } else if(child instanceof TXElement){
		removeWhiteSpaceNodes((Element)child);
	    }
	}
    }


    public void buildNodes(NodeList nl, String tagID){
	int indexnl = 0;
	boolean found = false;
	//System.out.println("Node Length: "+nl.getLength());

	while(indexnl < (nl.getLength())){
	    Node childNL = nl.item(indexnl);
	    String childName = childNL.getNodeName();
	    System.out.println("Node Name: "+childName);

	    if(childName != "#text") {
		//System.out.println("Attribute Name: "+((Element)childNL).getAttribute("Name"));
		//System.out.println("Attribute Type: "+((Element)childNL).getAttribute("Type"));
		tagID = childName;
	    }
	    String childValue = childNL.getNodeValue();
	    if (childNL instanceof TXText) {
		childValue = childNL.getNodeValue();
		System.out.println("Node Value: "+childValue);
	    } else if (childNL.hasChildNodes()){
		NodeList nextnodelist = childNL.getChildNodes();
		buildNodes(nextnodelist, tagID);
	    }
	    indexnl++;
	    if((tagID != null) && (childValue != null)) {
		if(keyVec.isEmpty() == true){
		    keyVec.addElement(tagID);
		    valueVec.addElement(childValue);
		    found = false;
		} else if(keyVec.isEmpty() != true){
		    for(int i = 0; i < keyVec.size(); i++){
			if (tagID.equals(keyVec.get(i))){
			    found = true;
			    value = (String)valueVec.get(i);
			    value = value + "+" + childValue;
			    valueVec.setElementAt(value, i);
			    break;
			}
		    }
		    if(found == false) {
			keyVec.addElement(tagID);
			valueVec.addElement(childValue);
			found = false;
		    }
		}
	    }
	}
    }
    

    private Vector getAllTags(Node node, String tag) {
	Vector result=new Vector();
	
	for(Node ch = node.getFirstChild(); ch!=null;
	    ch = ch.getNextSibling()) {
	    if(ch instanceof Element) {
		if(ch.getNodeName().equals(tag)) {
		    result.addElement(ch);
		    System.out.println("Node Name Tag: "+ch.getNodeName());
		    System.out.println("Attribute: "+((Element)ch).getAttribute("Name"));
		}
	    }
	}
	return result;
    }
}


