/**
 * This file handles <XSIL> tags assocated with an application descriptor.
 * For a particular code, the parameters and their values are stored
 * in a hash table.  
 */ 
package extensions.gem;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLDesc extends XSIL {

    public Vector hostList,hostListNames;
    public Hashtable paramHash=new Hashtable();

    boolean instantiated = false,constructed=false;
    
    public void construct(){
	hostList=new Vector();
	hostListNames=new Vector();
	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		paramHash.put(p.getName(),p.getText());
	    }
  	    else if(x instanceof parseXMLHost) {
  		hostList.addElement((parseXMLHost)x);
  		//hostListNames.addElement(x.getName());
		hostListNames.addElement(((parseXMLHost)x).getHost());
  	    }
	}
	constructed=true;
    }
    
    //We can instantiate separately from contructing, if we want.
    public void instantiate(){
	construct();
	instantiated=true;
    }
    
    /**
     * Returns the hashtable containing the application's parameters
     * and their values.
     */
    public Hashtable getCodeTagList() { 
	if(!constructed) construct();    //Just in case.
	return paramHash; 
    }
 
    /**
     * Returns the value for a particular tag.
     */ 
    public String getCodeTagValue(String paramName) {
	if(paramHash.containsKey(paramName)) {
	    return (String)paramHash.get(paramName);
	}
	else {
	    System.err.println("Parameter not found for this code!");
	    return null;
	}
    }
    
    /**
     * Returns the list of host machines that offer this code.
     */ 
    
    public Vector getHostListNames() { return hostListNames; }
    public Vector getHostList() { return hostList; }
}



