/**
 * Program Name: scriptFactory.java
 * Comments: This class contains a factory method for creating a specific
 * subclass of the createScript class.  For example, for PBS, there should
 * be a class createPBS, which we can create by
 *                scriptFactory.makeChild("PBS",cm)
 * where the first argument can be obtained from the ApplDesc.xml file and 
 * the second is an instance of the context manager class.
 */

package extensions.gem;
import WebFlow.*;
import WebFlow.ContextManager.*;
import java.util.*;

public class scriptFactory {
    public static createScript makeChild(String queueType, 
					 ContextManager cm,String name) {
	createScript thisScript=null;	
	String userName=name;
	System.out.println(queueType);
	if (queueType.equalsIgnoreCase("PBS")) {
	    thisScript=new createPBS(cm,userName);
	}
	else if(queueType.equalsIgnoreCase("DQS")) {
	    thisScript=new createDQS(cm,userName); 
	}
	else if(queueType.equalsIgnoreCase("LSF")) {
	    thisScript=new createLSF(cm,userName);
	}
	else if(queueType.trim().equalsIgnoreCase("GRD")) {
	    thisScript=new createGRD(cm,userName);
	}
	else if(queueType.trim().equalsIgnoreCase("CSH")) {
	    thisScript=new createCSH(cm,userName);
	}
	else 
	    System.err.println("Queue not supported.");
	return thisScript;
    }
    
    public static createScript makeChild(String queueType, 
					 ContextManagerBean cm,
					 String name) {
	createScript thisScript=null;	
	String userName=name;
	if (queueType.equalsIgnoreCase("PBS")) {
	    thisScript=new createPBS(cm,userName);
	}
	else if(queueType.equalsIgnoreCase("DQS")) {
	    thisScript=new createDQS(cm,userName); 
	}
	else if(queueType.equalsIgnoreCase("LSF")) {
	    thisScript=new createLSF(cm,userName);
	}
	else if(queueType.equalsIgnoreCase("GRD")) {
	    thisScript=new createGRD(cm,userName);
	}
	else if(queueType.trim().equalsIgnoreCase("CSH")) {
	    thisScript=new createCSH(cm,userName);
	}

	else 
	    System.err.println("Queue not supported.");
	return thisScript;
    }
    
    public static createScript makeChild(String queueType, 
					 moduleServerBean msb,String name) {
	createScript thisScript=null;	
	String userName=name;
	if(queueType.equalsIgnoreCase("LSF")) {
	    thisScript=new createLSF(msb,userName);
	}
	else 
	    System.err.println("Queue not supported.");
	return thisScript;
    }
}


