/**
 * Program Name: setPropBean.java
 * Comments: Store information needed to construct
 * the queue script from the request Object
 */

package extensions.gem;

import java.util.*;
import java.io.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.ContextManager.*;

public class setPropBean {

    ContextManager cm;
    ContextManagerBean my_cm;
    parseXMLBean parseXML;
    jobInfoBean storeInfo;
    nameEncodeBean nameEncode;
    boolean codenameflag = false;
    boolean machinenameflag = false;

    public setPropBean() {
	//Empty constructor
    }

    public void setXML(parseXMLBean parseXML) {
	this.parseXML = parseXML;
    }

    public void setCM(ContextManager cm) {
	this.cm = cm;
    }
    
    public  void setCM(ContextManagerBean cm) {
	this.my_cm=cm;
    }

    public void setSI(jobInfoBean storeInfo) {
	this.storeInfo = storeInfo;
    }

    public void setNE(nameEncodeBean nameEncode) {
	this.nameEncode = nameEncode;
    }

    public void setRequests(HttpServletRequest request){
	String paramName = null;
	String paramValue = null;
	Enumeration requestNames = request.getParameterNames();
	while(requestNames.hasMoreElements()) {
	    paramName = (String)requestNames.nextElement();
	    paramValue = request.getParameter(paramName);
	    if(paramName.equals("codeName")) {
		codenameflag = true;
		my_cm.setCurrentSessionProperty(paramName,paramValue);
	    }
	    else if(paramName.equals("machineName")) {
		machinenameflag = true;
		my_cm.setCurrentSessionProperty(paramName,paramValue);
	    }
	    else {
		my_cm.setCurrentSessionProperty(paramName,paramValue);	    
	    }
	    my_cm.setCurrentSessionProperty("shell","/bin/csh");
	    my_cm.setCurrentSessionProperty("queue","default");
	}

	if(codenameflag && machinenameflag) {
	    String code = my_cm.getCurrentSessionProperty("codeName");
	    String machine = my_cm.getCurrentSessionProperty("machineName"); 
	    
	    //Set the machine tag values.
	    setSessionProperties(parseXML.getCodeTagList(code));

	    //Put the environment variables into the hash table.
	    Hashtable hash=parseXML.getEnvironHash(code,machine);
	    Enumeration en=hash.keys();
	    String environString="";
	    while(en.hasMoreElements()) {
		String key=(String)en.nextElement();
		environString+=key+"+"+(String)hash.get(key)+"+";
	    }
	    environString=environString.substring(0,environString.length()-1);
	    my_cm.setCurrentSessionProperty("Environment",environString);

	    setSessionProperties(parseXML.getMachineTagList(code,machine));

	    codenameflag=false;
	    machinenameflag=false;
	}
    }

    private void setSessionProperties(Hashtable ht) {
	Enumeration en=ht.keys();
	while(en.hasMoreElements()) {
	    String name=(String)en.nextElement();
	    String value=(String)ht.get(name);
	    my_cm.setCurrentSessionProperty(name,value);
	}
    }

    public void setIOArrayRequests(HttpServletRequest request, boolean flag){

	if(flag) {
	    String NumOfInParam = my_cm.getCurrentSessionProperty("NumberOfInParams");
	    String NumOfOutFiles = my_cm.getCurrentSessionProperty("NumberOfOutFiles");
	    String NumOfInFiles=my_cm.getCurrentSessionProperty("NumberOfInFiles");
	    String NumOfOutParams=my_cm.getCurrentSessionProperty("NumberOfOutParams");

	    String[] inputpath = null;	
	    String[] outputpath = null;
	    String[] inputparams=null;
	    String[] outputparams=null;

	    String catinpath="",catoutpath="",catinparams="",catoutparams="";

	    if (!(NumOfInParam.trim().equals("0"))) {
		System.out.println(NumOfInParam);
		inputparams=request.getParameterValues("inputparameter");
		for(int i=0;i<inputparams.length;i++) catinparams+=inputparams[i]+"+";
	    }		
	    else catinparams = "null";
	    my_cm.setCurrentSessionProperty("inputParam",catinparams);

	    if (!(NumOfInFiles.trim().equals("0"))) {
		
		inputpath=request.getParameterValues("inputpath");
		for(int i=0;i<inputpath.length;i++) catinpath+=inputpath[i]+"+";
	    }		
	    else catinpath = "null";
	    my_cm.setCurrentSessionProperty("inputFiles",catinpath);
	    
	    if (!(NumOfOutFiles.trim().equals("0"))) {
		outputpath=request.getParameterValues("outputpath");
		for(int j=0;j<outputpath.length;j++) catoutpath+=outputpath[j]+"+";
	    }
	    else catoutpath = "null";
	    my_cm.setCurrentSessionProperty("outputFiles",catoutpath);	
	    
	    if (!(NumOfOutParams.trim().equals("0"))) {
		outputparams=request.getParameterValues("outputparameter");
		for(int j=0;j<outputparams.length;j++) catoutparams+=outputparams[j]+"+";
	    }
	    else catoutparams = "null";
	    my_cm.setCurrentSessionProperty("outputParams",catoutparams);

	} else {
	    //Deleted some lines.
	}
    }
}

